(defun text-extras-as-xml-expression (self)
  (when (om::get-extras self "text")
    (list "<direction placement=\"above\">"
          (list  "<direction-type>"
                 (format nil "<words default-y=\"33\" relative-x=\"15\">~a</words>" (om::thetext (car (om::get-extras self "text"))))
                 "</direction-type>")
          "</direction>")))

(defmethod cons-xml-expr ((self om::chord) &key free key (approx 2) part)
  (let* (;; (dur free) 
         (dur (if (listp free) (car free) free))
         (head-and-pts (get-head-and-points dur))
         (note-head (cadr (find (car head-and-pts) *note-types* :key 'car)))
         (nbpoints (cadr head-and-pts))
         (durtot (get-xml-duration self))  ;;; !!!!
         (inside (om::inside self))
         (chord-no-tied? (not (equal (write-to-string (type-of self)) "continuation-chord")))
         )
    (loop for note in inside 
          for i = 0 then (+ i 1) append 
          (let* ((note-values (mc->xmlvalues (om::midic note) approx))
                 (step (nth 1 note-values))
                 (alteration (nth 2 note-values))
                 (octave (nth 3 note-values)))
                         
            (list 
             (if chord-no-tied? (when (= i 0) (text-extras-as-xml-expression self)))
             (if chord-no-tied? (when (= i 0) (vel-extras-as-xml self)))
             (format nil "<note dynamics=\"~D\">" (midi-vel-to-mxml-vel (om::vel note)))
             (unless (= i 0) "<chord/>") ;;; if this is not the first note in the chord
             (remove nil 
                     (append 
                      (list "<pitch>"
                            (remove nil 
                                    (list (format nil "<step>~A</step>" step)
                                          (when alteration (format nil "<alter>~A</alter>" alteration))
                                          (format nil "<octave>~A</octave>" octave)))
                            "</pitch>"
                            (format nil "<duration>~A</duration>" durtot)
                            (tied self) ;;; ties (performance)
                            (let ((headstr (format nil "<type>~A</type>" note-head)))
                              (loop for i from 1 to nbpoints do (setf headstr (concatenate 'string headstr "<dot/>")))
                              headstr)
                            (when (find alteration *note-accidentals* :key 'car)  ;;; accidental (if any)
                              (format nil "<accidental>~A</accidental>" (cadr (find alteration *note-accidentals* :key 'car))))
                            (format nil "<instrument id=\"P~D-I~D\"/>" part (om::chan note))
                            )
                      (time-modifications self)
                      (makebeam self)
                      (groupnotation self)
                      ;(if chord-no-tied? (when (= i 0) (text-extras-as-xml self)))
                      (when (= i 0) (head-extras-as-xml self))
                      ))
             "</note>")
            ))))